gtkmm: Gdk::PixbufLoader Class Reference

gtkmm 2.24.4

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions

# Gdk::PixbufLoader Class Reference

Inheritance diagram for Gdk::PixbufLoader:
[legend]
Collaboration diagram for Gdk::PixbufLoader:
[legend]

List of all members.

## Public Member Functions
virtual | ~PixbufLoader ()
GdkPixbufLoader* | gobj ()
| Provides access to the underlying C GObject.
const GdkPixbufLoader* | gobj () const
| Provides access to the underlying C GObject.
GdkPixbufLoader* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
void | set_size (int width, int height)
void | write (const guint8* buf, gsize count)
| Causes the pixbuf loader to parse the next count bytes of an image.
void | close ()
| Informs a pixbuf loader that no further writes with PixbufLoader::write() will occur, so that it can free its internal loading structures.
Glib::RefPtr< Gdk::Pixbuf > | get_pixbuf ()
Glib::RefPtr < Gdk::PixbufAnimation > | get_animation ()
PixbufFormat | get_format () const
Glib::SignalProxy0< void > | signal_area_prepared ()
| This signal is emitted when the pixbuf loader has allocated the pixbuf in the desired size.
Glib::SignalProxy4< void, int, int, int, int > | signal_area_updated ()
| This signal is emitted when a significant area of the image being loaded has been updated.
Glib::SignalProxy0< void > | signal_closed ()
| This signal is emitted when close() is called.
Glib::SignalProxy2< void, int, int > | signal_size_prepared ()
| This signal is emitted when the pixbuf loader has been fed the initial amount of data that is required to figure out the size of the image that it will create.
## Static Public Member Functions
static Glib::RefPtr< PixbufLoader > | create ()
| Creates a new pixbuf loader object.
static Glib::RefPtr< PixbufLoader > | create (const Glib::ustring& image_type, bool mime_type=false)
| Constructs a pixbuf loader object for a specific image type.
## Protected Member Functions
| PixbufLoader ()
| Constructs a pixbuf loader object.
| PixbufLoader (const Glib::ustring& image_type, bool mime_type=false)
| Constructs a pixbuf loader object for a specific image type.
virtual void | on_area_prepared ()
virtual void | on_area_updated (int x, int y, int width, int height)
virtual void | on_closed ()
## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gdk::PixbufLoader > | wrap (GdkPixbufLoader* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Constructor & Destructor Documentation

virtual Gdk::PixbufLoader::~PixbufLoader | ( |  | ) | `[virtual]`

Gdk::PixbufLoader::PixbufLoader | ( |  | ) | `[protected]`

Constructs a pixbuf loader object.

Gdk::PixbufLoader::PixbufLoader | ( | const Glib::ustring & | image_type,
|  | bool | mime_type = `false`
| ) |  | `[explicit, protected]`

Constructs a pixbuf loader object for a specific image type.

Constructs a new pixbuf loader object that always attempts to parse image data as if it were an image of type image_type, instead of identifying the type automatically. Useful if you want an error if the image isn't the expected type, for loading image formats that can't be reliably identified by looking at the data, or if the user manually forces a specific type.

The image_type can be one of the types returned by Gdk::Pixbuf::get_formats(), or a MIME type.

Common MIME Types are listed here http://www.iana.org/assignments/media-types/ and here: http://www.freedesktop.org/Software/shared-mime-info

The list of non-mime-type image formats depends on what image loaders are installed, but typically "png", "jpeg", "gif", "tiff" and "xpm" are among the supported formats. To obtain the full list of supported image formats, call PixbufFormat::get_name() on each of the PixbufFormats returned by Gdk::Pixbuf::get_formats().

Parameters:

  image_type | Name of the image format to be loaded with the image.
  mime_type | If this is true then the image_type is a MIME type.

Exceptions:

  Gdk::PixbufError |

## Member Function Documentation

void Gdk::PixbufLoader::close | ( |  | ) |

Informs a pixbuf loader that no further writes with PixbufLoader::write() will occur, so that it can free its internal loading structures.

Also, tries to parse any data that hasn't yet been parsed; if the remaining data is partial or corrupt, an exception will be thrown. If you're just cancelling a load rather than expecting it to be finished, writing an empty `catch()` block to ignore errors is reasonable.

Exceptions:

  Gdk::PixbufError |
  Glib::FileError |

static Glib::RefPtr<PixbufLoader> Gdk::PixbufLoader::create | ( |  | ) | `[static]`

Creates a new pixbuf loader object.

Returns:
  A newly-created pixbuf loader.

static Glib::RefPtr<PixbufLoader> Gdk::PixbufLoader::create | ( | const Glib::ustring & | image_type,
|  | bool | mime_type = `false`
| ) |  | `[static]`

Constructs a pixbuf loader object for a specific image type.

Constructs a new pixbuf loader object that always attempts to parse image data as if it were an image of type image_type, instead of identifying the type automatically. Useful if you want an error if the image isn't the expected type, for loading image formats that can't be reliably identified by looking at the data, or if the user manually forces a specific type.

The image_type can be one of the types returned by Gdk::Pixbuf::get_formats(), or a MIME type.

Common MIME Types are listed here http://www.iana.org/assignments/media-types/ and here: http://www.freedesktop.org/Software/shared-mime-info

The list of non-mime-type image formats depends on what image loaders are installed, but typically "png", "jpeg", "gif", "tiff" and "xpm" are among the supported formats. To obtain the full list of supported image formats, call PixbufFormat::get_name() on each of the PixbufFormats returned by Gdk::Pixbuf::get_formats().

Parameters:

  image_type | Name of the image format to be loaded with the image.
  mime_type | If this is true then the image_type is a MIME type.

Exceptions:

  Gdk::PixbufError |

Glib::RefPtr<Gdk::PixbufAnimation> Gdk::PixbufLoader::get_animation | ( |  | ) |

PixbufFormat Gdk::PixbufLoader::get_format | ( |  | ) | const

Glib::RefPtr<Gdk::Pixbuf> Gdk::PixbufLoader::get_pixbuf | ( |  | ) |

const GdkPixbufLoader* Gdk::PixbufLoader::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

GdkPixbufLoader* Gdk::PixbufLoader::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

GdkPixbufLoader* Gdk::PixbufLoader::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

virtual void Gdk::PixbufLoader::on_area_prepared | ( |  | ) | `[protected, virtual]`

virtual void Gdk::PixbufLoader::on_area_updated | ( | int | x,
|  | int | y,
|  | int | width,
|  | int | height
| ) |  | `[protected, virtual]`

virtual void Gdk::PixbufLoader::on_closed | ( |  | ) | `[protected, virtual]`

void Gdk::PixbufLoader::set_size | ( | int | width,
|  | int | height
| ) |  |

Glib::SignalProxy0< void > Gdk::PixbufLoader::signal_area_prepared | ( |  | ) |

This signal is emitted when the pixbuf loader has allocated the pixbuf in the desired size.

After this signal is emitted, applications can call get_pixbuf() to fetch the partially-loaded pixbuf.

Prototype:
  `void on_my_area_prepared()`

Glib::SignalProxy4< void,int,int,int,int > Gdk::PixbufLoader::signal_area_updated | ( |  | ) |

This signal is emitted when a significant area of the image being loaded has been updated.

Normally it means that a complete scanline has been read in, but it could be a different area as well. Applications can use this signal to know when to repaint areas of an image that is being loaded.

Parameters:

  X | offset of upper-left corner of the updated area.
  y | Y offset of upper-left corner of the updated area.
  width | Width of updated area.
  height | Height of updated area.

Prototype:
  `void on_my_area_updated(int x, int y, int width, int height)`

Glib::SignalProxy0< void > Gdk::PixbufLoader::signal_closed | ( |  | ) |

This signal is emitted when close() is called.

It can be used by different parts of an application to receive notification when an image loader is closed by the code that drives it.

Prototype:
  `void on_my_closed()`

Glib::SignalProxy2< void,int,int > Gdk::PixbufLoader::signal_size_prepared | ( |  | ) |

This signal is emitted when the pixbuf loader has been fed the initial amount of data that is required to figure out the size of the image that it will create.

Applications can call set_size() in response to this signal to set the desired size to which the image should be scaled.

Parameters:

  width | The original width of the image.
  height | The original height of the image

Prototype:
  `void on_my_size_prepared(int width, int height)`

void Gdk::PixbufLoader::write | ( | const guint8 * | buf,
|  | gsize | count
| ) |  |

Causes the pixbuf loader to parse the next count bytes of an image.

It will return if the data was loaded successfully, and throw an exception if an error occurred. In the latter case, the loader will be closed, and will not accept further writes.

Parameters:

  buf | Pointer to image data.
  count | Length of the buf buffer in bytes.

Exceptions:

  Gdk::PixbufError |
  Glib::FileError |

## Friends And Related Function Documentation

Glib::RefPtr< Gdk::PixbufLoader > wrap | ( | GdkPixbufLoader * | object,
|  | bool | take_copy = `false`
| ) |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gdkmm/pixbufloader.h